{$O-}

Unit kbd; 




Interface


Type       (* SCANCODE DER TASTEN *)
  scanCode = (
    kNone, kEsc, k1, k2, k3, k4, k5, k6, k7, k8, k9, k0, kMinus, kEqual,
    kBack, kTab, kQ, kW, kE, kR, kT, kY, kU, kI, kO, kP, kLBracket,
    kRBracket, kEnter, kCtrl, kA, kS, kD, kF, kG, kH, kJ, kK, kL, kColon,
    kQuote, kTilde, kLShift, kBackSlash, kZ, kX, kC, kV, kB, kN, kM, kComma,
    kPeriod, kSlash, kRShift, kPadStar, kAlt, kSpace, kCaps, kF1, kF2, kF3,
    kF4, kF5, kF6, kF7, kF8, kF9, kF10, kNum, kScroll, kHome, kUp, kPgUp,
    kPadMinus, kLf, kPad5, kRt, kPadPlus, kend, kDn, kPgDn, kIns, kDel,
    kSysReq, kUnknown55, kUnknown56, kF11, kF12);


Var
 tastatur        ,
 tastaturspeicher : set of scaNCODE;
 letzte_taste : scanCode;


function  test_Key(nKey: ScanCode):byte;
procedure Neuer_tast_Int;
procedure restore_keyb;

function testmem_Key(nKey: ScanCode):byte;
procedure speicher_tasten;
procedure loesche_tasten;

Implementation
Uses Dos;

Var
  alt_tast_int : Pointer;            (* ALTER TASTATURHandler *)

Procedure tastatur_intr; interrupt;   (* Neuer Handler *)
Var
  k : scanCode;
  b : Byte;
begin

  Asm
   in al, $60;
   mov b, al;
   and al, $7F;
   mov k, al;
   pushF;
   call [alt_tast_int];                {allow BIOS to process also}
  end;

  memW[$40 : $1A] := memW[$40 : $1C];  (* lsche BIOS tastatur buffer *)

  if shortint(b) >= 0 then
  begin
    tastatur := tastatur + [k];        (* Taste gedrckt *)
    letzte_taste := k;
  end
  else
  if b <> $E0 then
    tastatur := tastatur - [k];
         (* Taste losgelassen *)
end;


procedure Neuer_tast_Int;
begin

  asm
    mov AX,$0305;
    mov Bx,0;
    Int $16;
  end;
  tastatur := [];                (* Keine Taste gedrckt *)
  letzte_taste := kNone;
  getIntVec(9, alt_tast_int);    (* ALTE ADRESSE SICHERN *)
  setIntVec(9, @tastatur_intr);  (* NEUE ADRESSE SETZTEN *)

end;


function test_Key(nKey: ScanCode):byte;
begin
  test_key:=0;                  (* TASTE NICHT VORHANDEN *)
  if nKey in tastatur
  then
     test_key:=1;
end;



function testmem_Key(nKey: ScanCode):byte;
begin
  testmem_key:=0;                  (* TASTE NICHT VORHANDEN *)
  if nKey in tastaturspeicher
  then
     testmem_key:=1;
end;


procedure speicher_tasten;
begin
      tastaturspeicher:=tastatur;
end;

procedure loesche_tasten;
begin
      tastaturspeicher:=[];
      tastatur:=[];
end;


procedure restore_keyb;
begin
  setIntVec(9, alt_tast_int);  (* ALTE ADRESSE SETZTEN *)

  asm
    mov AX,$0305;
    mov BH,1;
    mov bl,0;
    Int $16;
  end;
end;


end.