(****************************************************************************)
(***     'C'-Version  (C) Marcel de Kogel 1996,1997                       ***)
(***     Pascalversion (c) by M.Franzen 1997                              ***)
(***     You are not allowed to distribute this software commercially     ***)
(***     Please, notify me, if you make any changes to this file          ***)
(****************************************************************************)



uses dos,crt,z80das;


type  spei = array[0..$FFFF-1] of byte;

var   speicher:^spei;

      rom:file of byte;
      aus:text;

      i:word;
    ruck:string;
      pc:word;
    name,
    ausgn_:string;
    le,
    start,
    ende   :word;

    code   :integer;

    ausgn:pathstr;
    dir:dirstr;
    nam:namestr;
    ext:extstr;
begin


      name:=paramstr(1);
      if paramcount=0
          then
            begin
                 writeln('USAGE : Z80dasm [LW][PATH]Name.ext  [startaddr] [endaddr]');
                 writeln('        Eingabe der Addr in Hex : $XXXX');
                 writeln('        Eingabe in dezimal      :  xxxx');
            end
      else
        begin


             ausgn:=name;
             Fsplit(ausgn,dir,nam,ext);

             ausgn:=dir+nam+'.ASM';

             assign(rom,name);
             assign(aus,ausgn);

             rewrite(aus);

             reset(rom);
             le:=filesize(rom);


             start:=0; ende:=le;
             if paramcount < 2
             then
              begin
                repeat
                   write('Startaddr (',start:5,') :');readln(start);
                until start < le;
                repeat
                   write('Enaddr (',ende:5,') :');readln(ende);
                until (ende <= le) and (ende > start);
              end;

             if paramcount = 2
             then
                 val(paramstr(2),start,code);

             if paramcount = 3
             then
                 val(paramstr(3),ende,code);

             writeln('Z80 Disam  (c) by M.Franzen 1997 ',#10);
             writeln('Eingangsdatei ',name);
             writeln('Dasasambliere ',le,5,' Bytes');
             writeln('STARTADR :',start:5,'    ','ENDADDR :',ende:5);
             Writeln('Ausgangsdatei : ',ausgn
             );

             writeln(aus,';Z80 Disam  (c) by M.Franzen 1997 ',#10);
             writeln(aus,';Eingangsdatei ',name);
             writeln(aus,';Dasasambliere ',le,5,' Bytes',#10);
             writeln(aus,';STARTADR :',start:5,'    ','ENDADDR :',ende:5);

             if le > $FFFF-1
               then
                  begin
                       writeln('Achtung , die Datei ist zu gro, es werden nur die ersten ');
                       writeln('$FFFD Bytes bearbeitet !! Prfen sie, ob es sich um ein ');
                       writeln('Z80 Code handelt ');
                       le:=$FFFF-2;
                  end;



             getmem(speicher,le+1);

             for i:=0 to le - 1
             do
               read(rom,speicher^[i]);

             close(rom);

             pc:=start;

             repeat

                   i:=z80_dasm(@speicher^[pc],pc,ruck);
                   pc:=pc+i;
                   writeln(aus,hex(pc-i,4),dump(addr(speicher^[pc-i]),i),' ',ruck);
             until pc >= ende;
             freemem(speicher,le+1);

             writeln('Fertig ');

             close(aus);
          end;
end.